

#include "freertos/FreeRTOS.h"
#include "driver/uart.h"
#include <cstring>
#include <string>
#include "flatbuffers/util.h"
#include "obis.h"



const uart_port_t uart_num = UART_NUM_2;

void obis_init(void) {

uart_config_t uart_config = {
    .baud_rate = 9600,
    .data_bits = UART_DATA_8_BITS,
    .parity = UART_PARITY_DISABLE,
    .stop_bits = UART_STOP_BITS_1,
    .flow_ctrl = UART_HW_FLOWCTRL_DISABLE,
    .rx_flow_ctrl_thresh = 0,
    .use_ref_tick = false,
};

  // Install UART driver
  ESP_ERROR_CHECK(uart_driver_install(uart_num, 256, 0, 0, NULL, 0));

  // Configure UART parameters
  ESP_ERROR_CHECK(uart_param_config(uart_num, &uart_config));

  // Set UART pins(TX: IO4, RX: IO5, RTS: IO18, CTS: IO19)
  ESP_ERROR_CHECK(uart_set_pin(uart_num, OBIS_TRX_PIN, UART_PIN_NO_CHANGE, UART_PIN_NO_CHANGE, UART_PIN_NO_CHANGE));

}

// write obis value
void obis_write_str(const char *str) {
  char sbuf[64];
  sprintf(sbuf, "1-0:1.8.0*255(%s)\r\n", str);
  uart_write_bytes(uart_num, (const char*)sbuf, strlen(sbuf));
  uart_wait_tx_done(uart_num, portMAX_DELAY);

}
